<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>SQL-JOINS</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
</head>
<body>
<h1 id="visual-representation-of-sql-joins">Visual Representation of SQL Joins</h1>
<blockquote>
<p>This article describes SQL Joins in a visual manner, and also the most efficient way to write the visualized Joins.</p>
</blockquote>
<p>This is just a simple article visually explaining SQL JOINs. In this article I am going to discuss seven different ways you can return data from two relational tables. The seven Joins I will discuss are: Inner JOIN, Left JOIN, Right JOIN, Outer JOIN, Left Excluding JOIN, Right Excluding JOIN, Outer Excluding JOIN, while providing examples of each.</p>
<ul>
<li><a href="https://www.codeproject.com/KB/database/Visual_SQL_Joins/visual_sql_joins.zip">Download Visual SQL JOINs examples - 1.09 KB</a></li>
<li><a href="https://www.codeproject.com/KB/database/Visual_SQL_Joins/Visual_SQL_JOINS_orig.jpg">Download Visual SQL JOINs cheat sheet - 143 KB</a></li>
</ul>
<h2 id="background">Background</h2>
<p>I’m a pretty visual person. Things seem to make more sense as a picture. I looked all over the Internet for a good graphical representation of SQL <code>JOIN</code>s, but I couldn’t find any to my liking. Some had good diagrams but lacked completeness (they didn’t have all the possible JOINs), and some were just plain terrible. So, I decided to create my own and write an article about it.</p>
<h2 id="using-the-code">Using the code</h2>
<p>I am going to discuss seven different ways you can return data from two relational tables. I will be excluding cross Joins and self referencing Joins. The seven Joins I will discuss are shown below:</p>
<ol type="1">
<li><code>INNER JOIN</code></li>
<li><code>LEFT JOIN</code></li>
<li><code>RIGHT JOIN</code></li>
<li><code>OUTER JOIN</code></li>
<li><code>LEFT JOIN EXCLUDING INNER JOIN</code></li>
<li><code>RIGHT JOIN EXCLUDING INNER JOIN</code></li>
<li><code>OUTER JOIN EXCLUDING INNER JOIN</code></li>
</ol>
<p>For the sake of this article, I’ll refer to 5, 6, and 7 as <code>LEFT EXCLUDING JOIN</code>, <code>RIGHT EXCLUDING JOIN</code>, and <code>OUTER EXCLUDING JOIN</code>, respectively. Some may argue that 5, 6, and 7 are not really joining the two tables, but for simplicity, I will still refer to these as Joins because you use a SQL Join in each of these queries (but exclude some records with a <code>WHERE</code> clause).</p>
<h4 id="inner-join">Inner JOIN</h4>
<p>INNER_JOIN.png</p>
<figure>
<img src="https://www.codeproject.com/KB/database/Visual_SQL_Joins/INNER_JOIN.png" alt="Visual_SQL_Joins/INNER_JOIN.png" /><figcaption>Visual_SQL_Joins/INNER_JOIN.png</figcaption>
</figure>
<p>This is the simplest, most understood Join and is the most common. This query will return all of the records in the left table (table A) that have a matching record in the right table (table B). This Join is written as follows:</p>
<p>SELECT <em>&lt;select_list&gt;</em> FROM Table_A A INNER JOIN Table_B B ON A.Key = B.Key</p>
<h4 id="left-join">Left JOIN</h4>
<figure>
<img src="https://www.codeproject.com/KB/database/Visual_SQL_Joins/LEFT_JOIN.png" alt="Visual_SQL_Joins/LEFT_JOIN.png" /><figcaption>Visual_SQL_Joins/LEFT_JOIN.png</figcaption>
</figure>
<p>This query will return all of the records in the left table (table A) regardless if any of those records have a match in the right table (table B). It will also return any matching records from the right table. This Join is written as follows:</p>
<p>SELECT <em>&lt;select_list&gt;</em> FROM Table_A A LEFT JOIN Table_B B ON A.Key = B.Key</p>
<h4 id="right-join">Right JOIN</h4>
<figure>
<img src="https://www.codeproject.com/KB/database/Visual_SQL_Joins/RIGHT_JOIN.png" alt="Visual_SQL_Joins/RIGHT_JOIN.png" /><figcaption>Visual_SQL_Joins/RIGHT_JOIN.png</figcaption>
</figure>
<p>This query will return all of the records in the right table (table B) regardless if any of those records have a match in the left table (table A). It will also return any matching records from the left table. This Join is written as follows:</p>
<p>SELECT <em>&lt;select_list&gt;</em> FROM Table_A A RIGHT JOIN Table_B B ON A.Key = B.Key</p>
<h4 id="outer-join">Outer JOIN</h4>
<figure>
<img src="https://www.codeproject.com/Articles/33052/Visual-Representation-of-SQL-Joins/FULL_OUTER_JOIN.png" alt="Visual_SQL_Joins/FULL_OUTER_JOIN.png" /><figcaption>Visual_SQL_Joins/FULL_OUTER_JOIN.png</figcaption>
</figure>
<p>This Join can also be referred to as a <code>FULL OUTER JOIN</code> or a <code>FULL JOIN</code>. This query will return all of the records from both tables, joining records from the left table (table A) that match records from the right table (table B). This Join is written as follows:</p>
<p>SELECT <em>&lt;select_list&gt;</em> FROM Table_A A FULL OUTER JOIN Table_B B ON A.Key = B.Key</p>
<h4 id="left-excluding-join">Left Excluding JOIN</h4>
<figure>
<img src="https://www.codeproject.com/KB/database/Visual_SQL_Joins/LEFT_EXCLUDING_JOIN.png" alt="Visual_SQL_Joins/LEFT_EXCLUDING_JOIN.png" /><figcaption>Visual_SQL_Joins/LEFT_EXCLUDING_JOIN.png</figcaption>
</figure>
<p>This query will return all of the records in the left table (table A) that do not match any records in the right table (table B). This Join is written as follows:</p>
<p>SELECT <em>&lt;select_list&gt;</em> FROM Table_A A LEFT JOIN Table_B B ON A.Key = B.Key WHERE B.Key IS NULL</p>
<h4 id="right-excluding-join">Right Excluding JOIN</h4>
<figure>
<img src="https://www.codeproject.com/KB/database/Visual_SQL_Joins/RIGHT_EXCLUDING_JOIN.png" alt="Visual_SQL_Joins/RIGHT_EXCLUDING_JOIN.png" /><figcaption>Visual_SQL_Joins/RIGHT_EXCLUDING_JOIN.png</figcaption>
</figure>
<p>This query will return all of the records in the right table (table B) that do not match any records in the left table (table A). This Join is written as follows:</p>
<p>SELECT <em>&lt;select_list&gt;</em> FROM Table_A A RIGHT JOIN Table_B B ON A.Key = B.Key WHERE A.Key IS NULL</p>
<h4 id="outer-excluding-join">Outer Excluding JOIN</h4>
<figure>
<img src="https://www.codeproject.com/KB/database/Visual_SQL_Joins/OUTER_EXCLUDING_JOIN.png" alt="Visual_SQL_Joins/OUTER_EXCLUDING_JOIN.png" /><figcaption>Visual_SQL_Joins/OUTER_EXCLUDING_JOIN.png</figcaption>
</figure>
<p>This query will return all of the records in the left table (table A) and all of the records in the right table (table B) that do not match. I have yet to have a need for using this type of Join, but all of the others, I use quite frequently. This Join is written as follows:</p>
<p>SELECT <em>&lt;select_list&gt;</em> FROM Table_A A FULL OUTER JOIN Table_B B ON A.Key = B.Key WHERE A.Key IS NULL OR B.Key IS NULL</p>
<h4 id="examples">Examples</h4>
<p>Suppose we have two tables, <em>Table_A</em> and <em>Table_B</em>. The data in these tables are shown below:</p>
<p><strong>TABLE_A</strong> PK Value —- ———- 1 FOX 2 COP 3 TAXI 6 WASHINGTON 7 DELL 5 ARIZONA 4 LINCOLN 10 LUCENT</p>
<p><strong>TABLE_B</strong> PK Value —- ———- 1 TROT 2 CAR 3 CAB 6 MONUMENT 7 PC 8 MICROSOFT 9 APPLE 11 SCOTCH</p>
<p>The results of the seven Joins are shown below:</p>
<p><strong>-- INNER JOIN</strong> SELECT A.PK AS A_PK, A.Value AS A_Value, B.Value AS B_Value, B.PK AS B_PK FROM Table_A A INNER JOIN Table_B B ON A.PK = B.PK</p>
<table>
<thead>
<tr class="header">
<th>A_PK</th>
<th style="text-align: center;">A_Value</th>
<th style="text-align: right;">B_Value</th>
<th style="text-align: right;">B_PK</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>1</td>
<td style="text-align: center;">FOX</td>
<td style="text-align: right;">TROT</td>
<td style="text-align: right;">1</td>
</tr>
<tr class="even">
<td>2</td>
<td style="text-align: center;">COP</td>
<td style="text-align: right;">CAR</td>
<td style="text-align: right;">2</td>
</tr>
<tr class="odd">
<td>3</td>
<td style="text-align: center;">TAXI</td>
<td style="text-align: right;">CAB</td>
<td style="text-align: right;">3</td>
</tr>
<tr class="even">
<td>6</td>
<td style="text-align: center;">WASHINGTON</td>
<td style="text-align: right;">MONUMENT</td>
<td style="text-align: right;">6</td>
</tr>
<tr class="odd">
<td>7</td>
<td style="text-align: center;">DELL</td>
<td style="text-align: right;">PC</td>
<td style="text-align: right;">7</td>
</tr>
</tbody>
</table>
<p>(5 row(s) affected)</p>
<p><strong>-- LEFT JOIN</strong> SELECT A.PK AS A_PK, A.Value AS A_Value, B.Value AS B_Value, B.PK AS B_PK FROM Table_A A LEFT JOIN Table_B B ON A.PK = B.PK</p>
<table>
<thead>
<tr class="header">
<th>A_PK</th>
<th style="text-align: center;">A_Value</th>
<th style="text-align: right;">B_Value</th>
<th style="text-align: right;">B_PK</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>1</td>
<td style="text-align: center;">FOX</td>
<td style="text-align: right;">TROT</td>
<td style="text-align: right;">1</td>
</tr>
<tr class="even">
<td>2</td>
<td style="text-align: center;">COP</td>
<td style="text-align: right;">CAR</td>
<td style="text-align: right;">2</td>
</tr>
<tr class="odd">
<td>3</td>
<td style="text-align: center;">TAXI</td>
<td style="text-align: right;">CAB</td>
<td style="text-align: right;">3</td>
</tr>
<tr class="even">
<td>4</td>
<td style="text-align: center;">LINCOLN</td>
<td style="text-align: right;">NULL</td>
<td style="text-align: right;">NULL</td>
</tr>
<tr class="odd">
<td>5</td>
<td style="text-align: center;">ARIZONA</td>
<td style="text-align: right;">NULL</td>
<td style="text-align: right;">NULL</td>
</tr>
<tr class="even">
<td>6</td>
<td style="text-align: center;">WASHINGTON</td>
<td style="text-align: right;">MONUMENT</td>
<td style="text-align: right;">6</td>
</tr>
<tr class="odd">
<td>7</td>
<td style="text-align: center;">DELL</td>
<td style="text-align: right;">PC</td>
<td style="text-align: right;">7</td>
</tr>
<tr class="even">
<td>10</td>
<td style="text-align: center;">LUCENT</td>
<td style="text-align: right;">NULL</td>
<td style="text-align: right;">NULL</td>
</tr>
</tbody>
</table>
<p>(8 row(s) affected)</p>
<p><strong>-- RIGHT JOIN</strong> SELECT A.PK AS A_PK, A.Value AS A_Value, B.Value AS B_Value, B.PK AS B_PK FROM Table_A A RIGHT JOIN Table_B B ON A.PK = B.PK</p>
<table>
<thead>
<tr class="header">
<th>A_PK</th>
<th style="text-align: center;">A_Value</th>
<th style="text-align: right;">B_Value</th>
<th style="text-align: right;">B_PK</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>1</td>
<td style="text-align: center;">FOX</td>
<td style="text-align: right;">TROT</td>
<td style="text-align: right;">1</td>
</tr>
<tr class="even">
<td>2</td>
<td style="text-align: center;">COP</td>
<td style="text-align: right;">CAR</td>
<td style="text-align: right;">2</td>
</tr>
<tr class="odd">
<td>3</td>
<td style="text-align: center;">TAXI</td>
<td style="text-align: right;">CAB</td>
<td style="text-align: right;">3</td>
</tr>
<tr class="even">
<td>6</td>
<td style="text-align: center;">WASHINGTON</td>
<td style="text-align: right;">MONUMENT</td>
<td style="text-align: right;">6</td>
</tr>
<tr class="odd">
<td>7</td>
<td style="text-align: center;">DELL</td>
<td style="text-align: right;">PC</td>
<td style="text-align: right;">7</td>
</tr>
<tr class="even">
<td>NULL</td>
<td style="text-align: center;">NULL</td>
<td style="text-align: right;">MICROSOFT</td>
<td style="text-align: right;">8</td>
</tr>
<tr class="odd">
<td>NULL</td>
<td style="text-align: center;">NULL</td>
<td style="text-align: right;">APPLE</td>
<td style="text-align: right;">9</td>
</tr>
<tr class="even">
<td>NULL</td>
<td style="text-align: center;">NULL</td>
<td style="text-align: right;">SCOTCH</td>
<td style="text-align: right;">11</td>
</tr>
</tbody>
</table>
<p>(8 row(s) affected)</p>
<p><strong>-- OUTER JOIN</strong> SELECT A.PK AS A_PK, A.Value AS A_Value, B.Value AS B_Value, B.PK AS B_PK FROM Table_A A FULL OUTER JOIN Table_B B ON A.PK = B.PK</p>
<table>
<thead>
<tr class="header">
<th>A_PK</th>
<th style="text-align: center;">A_Value</th>
<th style="text-align: right;">B_Value</th>
<th style="text-align: right;">B_PK</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>1</td>
<td style="text-align: center;">FOX</td>
<td style="text-align: right;">TROT</td>
<td style="text-align: right;">1</td>
</tr>
<tr class="even">
<td>2</td>
<td style="text-align: center;">COP</td>
<td style="text-align: right;">CAR</td>
<td style="text-align: right;">2</td>
</tr>
<tr class="odd">
<td>3</td>
<td style="text-align: center;">TAXI</td>
<td style="text-align: right;">CAB</td>
<td style="text-align: right;">3</td>
</tr>
<tr class="even">
<td>6</td>
<td style="text-align: center;">WASHINGTON</td>
<td style="text-align: right;">MONUMENT</td>
<td style="text-align: right;">6</td>
</tr>
<tr class="odd">
<td>7</td>
<td style="text-align: center;">DELL</td>
<td style="text-align: right;">PC</td>
<td style="text-align: right;">7</td>
</tr>
<tr class="even">
<td>NULL</td>
<td style="text-align: center;">NULL</td>
<td style="text-align: right;">MICROSOFT</td>
<td style="text-align: right;">8</td>
</tr>
<tr class="odd">
<td>NULL</td>
<td style="text-align: center;">NULL</td>
<td style="text-align: right;">APPLE</td>
<td style="text-align: right;">9</td>
</tr>
<tr class="even">
<td>NULL</td>
<td style="text-align: center;">NULL</td>
<td style="text-align: right;">SCOTCH</td>
<td style="text-align: right;">11</td>
</tr>
<tr class="odd">
<td>5</td>
<td style="text-align: center;">ARIZONA</td>
<td style="text-align: right;">NULL</td>
<td style="text-align: right;">NULL</td>
</tr>
<tr class="even">
<td>4</td>
<td style="text-align: center;">LINCOLN</td>
<td style="text-align: right;">NULL</td>
<td style="text-align: right;">NULL</td>
</tr>
<tr class="odd">
<td>10</td>
<td style="text-align: center;">LUCENT</td>
<td style="text-align: right;">NULL</td>
<td style="text-align: right;">NULL</td>
</tr>
</tbody>
</table>
<p>(11 row(s) affected)</p>
<p><strong>-- LEFT EXCLUDING JOIN</strong> SELECT A.PK AS A_PK, A.Value AS A_Value, B.Value AS B_Value, B.PK AS B_PK FROM Table_A A LEFT JOIN Table_B B ON A.PK = B.PK WHERE B.PK IS NULL</p>
<table>
<thead>
<tr class="header">
<th>A_PK</th>
<th style="text-align: center;">A_Value</th>
<th style="text-align: right;">B_Value</th>
<th style="text-align: right;">B_PK</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>4</td>
<td style="text-align: center;">LINCOLN</td>
<td style="text-align: right;">NULL</td>
<td style="text-align: right;">NULL</td>
</tr>
<tr class="even">
<td>5</td>
<td style="text-align: center;">ARIZONA</td>
<td style="text-align: right;">NULL</td>
<td style="text-align: right;">NULL</td>
</tr>
<tr class="odd">
<td>10</td>
<td style="text-align: center;">LUCENT</td>
<td style="text-align: right;">NULL</td>
<td style="text-align: right;">NULL</td>
</tr>
<tr class="even">
<td>(3 ro</td>
<td style="text-align: center;">w(s) affect</td>
<td style="text-align: right;">ed)</td>
<td style="text-align: right;"></td>
</tr>
</tbody>
</table>
<p><strong>-- RIGHT EXCLUDING JOIN</strong> SELECT A.PK AS A_PK, A.Value AS A_Value, B.Value AS B_Value, B.PK AS B_PK FROM Table_A A RIGHT JOIN Table_B B ON A.PK = B.PK WHERE A.PK IS NULL</p>
<table>
<thead>
<tr class="header">
<th>A_PK</th>
<th style="text-align: center;">A_Value</th>
<th style="text-align: right;">B_Value</th>
<th style="text-align: right;">B_PK</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>NULL</td>
<td style="text-align: center;">NULL</td>
<td style="text-align: right;">MICROSOFT</td>
<td style="text-align: right;">8</td>
</tr>
<tr class="even">
<td>NULL</td>
<td style="text-align: center;">NULL</td>
<td style="text-align: right;">APPLE</td>
<td style="text-align: right;">9</td>
</tr>
<tr class="odd">
<td>NULL</td>
<td style="text-align: center;">NULL</td>
<td style="text-align: right;">SCOTCH</td>
<td style="text-align: right;">11</td>
</tr>
</tbody>
</table>
<p>(3 row(s) affected)</p>
<p><strong>-- OUTER EXCLUDING JOIN</strong> SELECT A.PK AS A_PK, A.Value AS A_Value, B.Value AS B_Value, B.PK AS B_PK FROM Table_A A FULL OUTER JOIN Table_B B ON A.PK = B.PK WHERE A.PK IS NULL OR B.PK IS NULL</p>
<table>
<thead>
<tr class="header">
<th>A_PK</th>
<th style="text-align: center;">A_Value</th>
<th style="text-align: right;">B_Value</th>
<th style="text-align: right;">B_PK</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>NULL</td>
<td style="text-align: center;">NULL</td>
<td style="text-align: right;">MICROSOFT</td>
<td style="text-align: right;">8</td>
</tr>
<tr class="even">
<td>NULL</td>
<td style="text-align: center;">NULL</td>
<td style="text-align: right;">APPLE</td>
<td style="text-align: right;">9</td>
</tr>
<tr class="odd">
<td>NULL</td>
<td style="text-align: center;">NULL</td>
<td style="text-align: right;">SCOTCH</td>
<td style="text-align: right;">11</td>
</tr>
<tr class="even">
<td>5</td>
<td style="text-align: center;">ARIZONA</td>
<td style="text-align: right;">NULL</td>
<td style="text-align: right;">NULL</td>
</tr>
<tr class="odd">
<td>4</td>
<td style="text-align: center;">LINCOLN</td>
<td style="text-align: right;">NULL</td>
<td style="text-align: right;">NULL</td>
</tr>
<tr class="even">
<td>10</td>
<td style="text-align: center;">LUCENT</td>
<td style="text-align: right;">NULL</td>
<td style="text-align: right;">NULL</td>
</tr>
</tbody>
</table>
<p>(6 row(s) affected)</p>
<p>Note on the <code>OUTER JOIN</code> that the inner joined records are returned first, followed by the right joined records, and then finally the left joined records (at least, that’s how my Microsoft SQL Server did it; this, of course, is without using any <code>ORDER BY</code> statement).</p>
<p>You can visit the Wikipedia article for more info <a href="http://en.wikipedia.org/wiki/Sql_join" title="Wikipedia Entry for SQL Joins">here</a> (however, the entry is not graphical).</p>
<p>I’ve also created a cheat sheet that you can print out if needed. If you right click on the image below and select “Save Target As…”, you will download the full size image.</p>
<p><a href="https://www.codeproject.com/KB/database/Visual_SQL_Joins/Visual_SQL_JOINS_orig.jpg" title="Click to enlarge"><img src="https://www.codeproject.com/KB/database/Visual_SQL_Joins/Visual_SQL_JOINS_V2.png" alt="Image 8" /></a></p>
</body>
</html>
